<?php
/**
 * @version 0.8.1b 
 * @package ZiMB Comment
 * @copyright Copyright (C) 2009 ZiMB LLC. All rights reserved.
 */

jimport ( 'joomla.application.component.controller' );
jimport ( 'joomla.utilities.date' );
require_once(JPATH_COMPONENT.DS.'SecureImage'.DS.'securimage.php');
class zimbcommentController_ extends JController {
	
	/**
	 * Custom Constructor
	 */
	//DEVNOTE: register task - Register (map) a task to a method in the class
	//function registerTask( $task, $method )
	function __construct($default = array()) {
		parent::__construct ( $default );
	}
	
	/**
	 * Cancel operation
	 */
	function cancel() {
		$this->setRedirect ( 'index.php' );
	}
	
	function display() {

		global $mainframe;
		$ipAddress = $_SERVER["REMOTE_ADDR"];
		$jSession = &JFactory::getSession();
		$articleId = JRequest::getVar ( 'articleId' );
		$activeUser = & JFactory::getUser ();
		$params = & JComponentHelper::getParams ( 'com_zimbcomment' );
		$commentText = $params->get ( 'commentText', 'Comments' );
		$allowGuests = $params->get ( 'allowGuests', 0 );
		$guestStatus = $params->get ( 'guestStatus', 0 );
		$userStatus = $params->get ( 'userStatus', 1 );
		$emailRequired = $params->get ( 'emailRequired', 1 );
		$useCaptcha = $params->get('useCaptcha', 1);
		$bbCode = $params->get('bbCode', 1);
		$useCss = $params->get('useCss', 0);
		$useDojo = $params->get('useDojo', 0);
		$message = "";
		$error = "";
		$sq = "'";
		$html = "";
		switch ( $this->_task) {
			case "default" :
				$param = "default";
			break;
			case "Delete" :
				$param = "delete";
			break;
			case "add" :
				$param = "add";
			break;
			case "save" :
				//////////////////////////////////////////////
				//   Handle Save Comment Functionality      //
				//////////////////////////////////////////////
				
				if ($useCaptcha == 1)
				{
					$securimage = new Securimage($jSession);
					$captcha_code = JRequest::getVar('captcha_code');
					$saved_code = $jSession->get('secureimage_code_value');
					if (strtolower($saved_code) != strtolower($captcha_code)) 
					{
					  // 	the code was incorrect
  				  	// handle the error accordingly with your other error checking
						$error = "You typed in the wrong value.  Please try again.";
			  				
					}
				}
				
				
				if (! $activeUser->guest) {
					$user = $activeUser->id;
					$email = $activeUser->email;
					$web = "";
				} else {
					$web = JRequest::getVar ( 'web' );
					if (substr ( $web, 0, 7 ) != "http://") {
						$web = "http://" . $web;
					}
					$email = JRequest::getVar ( 'email' );
					$user = JRequest::getVar ( 'user' );
				}
				if ($emailRequired == 1) {
					if ($email == "")
					{
						$error = "Must provide e-mail address.";
					}
					elseif (!eregi("^([a-z]|[0-9]|\.|-|_)+@([a-z]|[0-9]|\.|-|_)+\.([a-z]|[0-9]){2,3}$", $email))
					{
						$error = "The e-mail, " . $email . ", is not valid.";
					}
				}
				

				
				
				if ($user == "") {
					$error = "You must enter a user name to save comment.";
				}
				
				$comments = JRequest::getVar ( 'comments' );
				if ($comments == "") {
					
					$error = "You must enter text to save comment.";
				}
				$datetime = date ( "y-m-d H:i:s", time () );
				$db = &JFactory::getDBO ();
				$published = 0;
				if (! $activeUser->guest) {
					$isUser = 1;
					$published = $userStatus;
				} else {
					if ($allowGuests == 0) {
						$error = "You must be logged in to comment.";
					}
					$isUser = 0;
					$published = $guestStatus;
				}
				
				// Only save to database if no errors.
				if ($error == "") {
					$query = "INSERT INTO " . $db->nameQuote ( '#__zimbComment_Comment' ) . " (articleId, content, handle, isUser, email, url, published, saved, ordering, hits, ipAddress) VALUES (" . $articleId . ", " . $db->Quote ( $comments) . ", " . $db->Quote ( $user ) . ", " . $isUser . ", " . $db->Quote ( $email ) . ", " . $db->Quote ( $web ) . ", " . $published . ", " . $db->Quote ( $datetime ) . ", " . 1 . ", " . 1 . ", " . $db->Quote($ipAddress) .  ")";
					$db->setQuery ( $query );
					$db->execute ( $query );
					if ($published == 0)
					{
						$message = "Your comment has been held for review by the system administrator.";	
					}
				} else {
					$param = "add";
				}
			
			break;
			case "captcha":
				$img = new securimage($jSession);
				$img->show(); 
				die($jSession->get('securimage_code_value'));
			default :
				$param = "none";
			break;
		}
		$model = &JModel::getInstance ( 'zimbCommentComponentModel' );
		
		// Get Comments for article ID
		$db = &JFactory::getDBO ();
		$path = JURI::base () . "index2.php?option=com_zimbcomment";
		$db->setQuery ( "SELECT * FROM " . $db->nameQuote ( '#__zimbComment_Comment' ) . " WHERE " . $db->nameQuote ( 'articleId' ) . " = " . $articleId . " AND " . $db->nameQuote ( 'published' ) . " = 1 ORDER BY " . $db->nameQuote ( 'saved' ) );
		$results = $db->loadObjectList ();
		// Print out each comment.	
		$count = 0;
		foreach ( $results as $result ) {
			$html .= '<TABLE style="width:100%">';
			$html .= '<TR><TD style="width:10%;">';
			$count += 1;
			$html .= $count;
			$html .= "</TD>";
			$html .= '<TD style="width:85%;"><DIV style="word-wrap:break-word; WIDTH:100%;">';
			$webReadyComment = $this->_WebReady($result->content);
			$html .= $webReadyComment;
			$html .= "</DIV></TD></TR>";
			$html .= "<TR><TD colspan=3><HR></TD></TR></TABLE>";
			$html .= "<TABLE><TR><TD>Posted by:&nbsp;";
			if ($result->url && $result->url != 'http://') {
				$html .= '<a href="' . $result->url . '">';
			} elseif ($result->email) {
				//$html .= '<a href="mailto:' . $result->email . '">';
			}
			$handle = "";
			if ($result->isUser) {
				
				$query = "SELECT " . $db->nameQuote ( 'username' ) . " from " . $db->nameQuote ( '#__users' ) . " WHERE " . $db->nameQuote ( 'id' ) . " = " . $result->handle;
				$db->setQuery ( $query );
				$handle = $db->loadResult ();
			} else {
				$handle = $result->handle;
			}
			$html .= $handle;
			if ($result->url) {
				$html .= '</a>';
			} elseif ($result->email) {
				//$html .= '</a>';
			}
			$html .= "</TD><TD> on &nbsp;";
			//$html .= date("l, F j, Y - g:i:s A", $result->saved);
			$date = new JDate ( $result->saved );
			$dateHtml = $date->toFormat ( "%A, %B %e, %Y at %I:%M:%S %p" );
			$html .= $dateHtml;
			$html .= "</TR></TABLE><BR />";
		}
		if ($useCss)
		{
			$css = '"hideComment"';
		}
		else 
		{
			$css = '"modifydate"';
		}
		
		// Add area for adding comments.
		$html .= "<table><tr><td>";
		$html .= '<div class=' . $css . ' onclick="hideComments(' . $sq . 'COMMENT' . $articleId . $sq . ', ' . $sq . $path . $sq . ', ' . $sq . $articleId . $sq . ');" onmouseover = "toHand();" onmouseout="toDefault();">';
		$html .= "Hide Comments</div></td>";
		$html .= "<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>";
		if ($param != "add") {
			if ($useCss)
			{
				$css = '"addComment"';
			}
			else 
			{
				$css = '"modifydate"';
			}
			$html .= '<td><div class=' . $css . ' onclick="addComments(' . $sq . 'COMMENT' . $articleId . $sq . ', ' . $sq . $path . $sq . ', ' . $sq . $articleId . $sq . ');" onmouseover = "toHand();" onmouseout="toDefault();">';
			
			$html .= "Add Comment</div></td></tr></table>";
			if ($message != "")
			{
				$html .= '<table style="width: 100%;"><tr><td colspan=3><span style="color:red;">' . $message . '</span></td></tr></table>';
			}
		} else {
			$canComment = (! $activeUser->guest || $allowGuests == 1);
			if ($canComment) {
				$html .= "</tr></table>";
				$html .= "<BR />";
				$html .= '<form id="ADDCOMMENT' . $articleId . '">';
				$html .= '<table style="width: 100%">';
				
				if (! $activeUser->guest) {
					$html .= "<tr><td>User</td><td>" . $activeUser->username . "</td></tr>";
					$html .= '<input type="hidden" id="user" value="' . $activeUser->id . '">';
					$html .= '<input type="hidden" id="email" value="' . $activeUser->email . '">';
					$html .= '<input type="hidden" id="web" value="">';
				} else {
					$html .= "<tr><td>User</td>";
					$html .= '<td><input type="text" id="user" value="' . $user . '"><span style="color:red">*</span></td></tr>';
					$html .= "<tr><td>E-Mail</td>";
					$html .= '<td><input type="text" id="email" value="' . $email . '">';
					if ($emailRequired == 1) {
						$html .= '<span style="color:red">*</span>';
					}
					$html .= '</td></tr>';
					$html .= "<tr><td>Website</td>";
					$html .= '<td><input type="text" id="web" value="' . $web . '"></td></tr>';
				
				}
				if ($bbCode == 1)
				{
					$BBAvailable = '<td><span style="color:blue;"><a href="http://en.wikipedia.org/wiki/BBCode" target="_BLANK">BBCode Available</a></span></td>';
				}
				$html .= '<tr><td>Comments<span style="color:red">*</span></td>' . $BBAvailable . '</tr>';
				$html .= '<tr><td colspan=3><textarea style="width:100%;" name="comments" rows=10>' . $comments . '</textarea></td></tr>';
				if ($useCaptcha == 1 && $activeUser->guest)
				{
					// Captcha Stuff Here
					$jsPath = 'components/com_zimbcomment';
					$html .= '<tr><td><img id="captcha" src="'.JURI::base().'index.php?option=com_zimbcomment&task=captcha" alt="CAPTCHA Image" /></td></tr>';
					$html .= '<tr><td><a href="#" onclick="document.getElementById('. "'" . 'captcha' . "'" . ').src = ' . "'" .JURI::base() .'index.php?option=com_zimbcomment&task=captcha' . "'" . '; return false">Reload Image</a></td></tr>';
					$html .= '<tr><td><input type="text" name="captcha_code" size="10" maxlength="6" /></td></tr>';
				}
				else
				{
					$html .= '<input type="hidden" name="captcha_code" size="10" maxlength="6" value="" />';
				}
				
			} else {
				$error = "You must be logged in to comment.";
			}
			if ($error != "") {
				$html .= '<tr><td colspan=3><span style="color:red;">' . $error . '</span></td></tr>';
			}
			if ($canComment) {
				$onClick = $sq . 'COMMENT' . $articleId . $sq . ', ' . $sq . $path . $sq . ', ' . $sq . $articleId . $sq;
				if ($useCss)
				{
					$css = '"saveCommentButton"';
				}
				else 
				{	
					$css = '"modifydate"';
				}
				$html .= '<tr><td style="align:right;"><div class=' . $css . ' onclick="saveComment(' . $onClick . ');" onmouseover = "toHand();" onmouseout="toDefault();">Save Comment</div></td></tr>';
			}
			$html .= "</table></form>";
		}
		
		$view = new DefaultComponentView ( );
		$view->setModel ( $model, true );
		if ($count > 0) {
			$html .= "|" . $count;
		}
		$view->display ( $html );
	}
	function _WebReady($comment)
	{
		// Thanks to http://www.phpit.net/article/create-bbcode-php/
		$return = htmlentities($comment);
		$return = str_replace("\n", "<BR>", $return);
		$return = preg_replace ('/\[b\](.*?)\[\/b\]/is', '<strong>$1</strong>', $return);
        $return  = preg_replace ('/\[i\](.*?)\[\/i\]/is', '<em>$1</em>', $return);
        $return = preg_replace ('/\[u\](.*?)\[\/u\]/is', '<u>$1</u>', $return);
        $return = preg_replace ('/\[quote\](.*?)\[\/quote\]/is', '<blockquote>$1</blockquote>', $return);
        $return = preg_replace ('/\[url\=(.*?)\](.*?)\[\/url\]/is', '<a href="$1">$2</a>', $return);
        $return = preg_replace ('/\[s\](.*?)\[\/s\]/is', '<s>$1</s>', $return);
        $return = preg_replace ('/\[code\](.*?)\[\/code\]/is', '<pre>$1</pre>', $return);
        $return = preg_replace ('/\[img\](.*?)\[\/img\]/is', '<img src="$1" width="100%" />', $return);
        $return = preg_replace ('/\[color\=(.*?)\](.*?)\[\/color\]/is', '<span style="color:$1;">$2</span>', $return);
		return $return;
	}
}
?>
